float4x4 World;
float4x4 View;
float4x4 Projection;
float4x4 WVP;

float3 Index;
 
float timeOfDay = 13;

float3 CameraPosition;
//float FogNear = 250;
//float FogFar = 300;

float4 HorizonColor;
float4 SunColor;		
float4 NightColor;

float4 MorningTint;		
float4 EveningTint;	

Texture2D Text : register(t0);

SamplerState linearSampler 
{
	Texture = <Text>;
	Filter = MIN_MAG_MIP_POINT;
	AddressU = Wrap;
	AddressV = Wrap;
	MaxLOD = 0;
};

struct VS_IN
{
	int pos : POSITION;
	float2 tex : TEXCOORD;
};
 
struct VS_OUTPUT
{
	float4 pos : POSITION;
	float4 col : COLOR;
	float2 tex : TEXCOORD;
	float shade : SHADE;
};
 
VS_OUTPUT VS( VS_IN input )
{
	int x = int(input.pos & 0xFF);
	int y = int((input.pos & 0xFF00)>> 8);
	int z = int((input.pos & 0xFF0000)>> 16);
	int w = int((input.pos & 0xFF000000)>> 24);
		
	float light = ((float)w)/16;

	float4 position = float4(Index.x * 16 + x, y, Index.z * 16 + z, 1);

	VS_OUTPUT output = (VS_OUTPUT)0;
	
	float4 worldPosition = mul(position, World);
	float4 viewPosition = mul(worldPosition, View);

    output.pos = mul(viewPosition, Projection);

	output.tex = input.tex;
	output.shade = light;

	//output.col.rgb = 1;

	return output;
}
 
float4 PS( VS_OUTPUT input ) : SV_Target
{
	input.col = Text.Sample(linearSampler, input.tex) * 1 ;

	return input.col;
}
 
  
technique10 BlockTechnique
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}

//technique10 Render
//{
//	pass P0
//	{
//		SetGeometryShader( 0 );
//		SetVertexShader( CompileShader( vs_4_0, VS() ) );
//		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	//}
//}