﻿using System.Runtime.InteropServices;

namespace Core.Model.Types
{
    [StructLayout(LayoutKind.Sequential)]
    public struct BoundingBoxF
    {
        public BoundingBoxF(Vector3F minimum, Vector3F maximum)
        {
            Minimum = minimum;
            Maximum = maximum;
        }

        public readonly Vector3F Maximum;
        public readonly Vector3F Minimum;

        public Vector3F GetPositiveVertex(Vector3F normal)
        {
            return
                new Vector3F(
                    normal.X >= 0 ? Maximum.X : Minimum.X,
                    normal.Y >= 0 ? Maximum.Y : Minimum.Y,
                    normal.Z >= 0 ? Maximum.Z : Minimum.Z);
        }

        private Vector3F GetNegativeVertex(Vector3F normal)
        {
            return
                new Vector3F(
                    normal.X >= 0 ? Minimum.X : Maximum.X,
                    normal.Y >= 0 ? Minimum.Y : Maximum.Y,
                    normal.Z >= 0 ? Minimum.Z : Maximum.Z);
        }
    }
}