﻿using System.Runtime.InteropServices;

namespace Core.Model.Types
{
    [StructLayout(LayoutKind.Sequential)]
    public struct PlaneF
    {
        public static PlaneF CreateFrustrumPlane(Vector3F normal, float d)
        {
            return new PlaneF(normal/normal.Length(), d/normal.Length());
        }

        private PlaneF(Vector3F normal, float d)
        {
            Normal = normal;
            D = d;
        }

        public readonly Vector3F Normal;

        public readonly float D;
    }
}
