﻿using Core.Model.Chunks;
using Core.Model.Types;
using SharpDX.DXGI;
using SharpDX.Direct3D;
using SharpDX.Direct3D10;

namespace SharpDX.Game.Model
{
    public class SharpDxChunk : Chunk
    {
        public Buffer IndexBuffer;
        public Buffer VertexBuffer;

        public SharpDxChunk(VectorIndex index)
            : base(index)
        {
        }

        public void DrawChunk(SharpDX.Direct3D10.Device device, EffectPass pass)
        {
            device.InputAssembler.SetIndexBuffer(IndexBuffer, Format.R32_UInt, 0);

            device.InputAssembler.PrimitiveTopology = PrimitiveTopology.TriangleList;
            device.InputAssembler.SetVertexBuffers(0,
                                                   new VertexBufferBinding(VertexBuffer,
                                                                           BlockVertex.BlockVertexSize, 0));

            pass.Apply();

            device.DrawIndexed(IndexCount, 0, 0);
        }
    }
}