﻿using Core.Model.Types;
using Microsoft.Xna.Framework;

namespace XNA.Game.Model.Helpers
{
    public static class TypeCompatibleHelper
    {
        public static Vector2 ConvertFromVector2F(Vector2F vector)
        {
            return new Vector2(vector.X, vector.Y);
        }

        public static Vector3 ConvertFromVector3F(Vector3F vector)
        {
            return new Vector3(vector.X, vector.Y, vector.Z);
        }

        public static Matrix ConvertFromMatrixF(MatrixF matrix)
        {
            return new Matrix(
                matrix.M11,
                matrix.M12,
                matrix.M13,
                matrix.M14,
                matrix.M21,
                matrix.M22,
                matrix.M23,
                matrix.M24,
                matrix.M31,
                matrix.M32,
                matrix.M33,
                matrix.M34,
                matrix.M41,
                matrix.M42,
                matrix.M43,
                matrix.M44
                );
        }

    }
}
